[Leetcode] 292. Nim Game 解题报告

题目

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思路

这算是一道智力题或者脑经急转弯了,小时候看到之后觉得好玩,还专门找来小石子和自己的玩伴们玩过。其实就是看石头的总数是不是4的倍数了,因为如果是4的倍数,那么你不可能赢,因为每次你拿i个,你的对手就拿4-i个,所以最后一个肯定是你的对手拿;如果不是4的倍数,那么你只需要第一次拿n % 4个,剩下你就可以碾压你的对手了:你的对手拿i个的话,你就拿3 - i个,保证他输。

代码

class Solution {
public:
    bool canWinNim(int n) {
        return n % 4 != 0;
    }
};

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值